module FFJPL.MethodLookup where {
	import FFJ.Syntax;
	import FFJPL.Definitions;
	import FFJPL.Functions;
	import FFJPL.FeatureModel;
	import FFJPL.Navigation;
	import Debug.Trace;

	mtype :: FeatureModel -> CT -> [Feature] -> Identifier -> ExtType -> [Signature];
	mtype fm ct omegas m (c,phi) | (c == "Object") = []
								 | (sometimes fm omegas phi) = case (getClass ct (c,phi)) of {
								                                 (False,c,d,fs,ms) -> case mdecl m ms of {
			                                                        Just (o,r,n,ps,b) -> (mtype fm ct omegas m (getPred ct (c,phi))) ++ (mtype fm ct omegas m (getLast ct d)) ++ [(fst (unzip ps),r)];
			                                                        Nothing -> (mtype fm ct omegas m (getPred ct (c,phi))) ++ (mtype fm ct omegas m (getLast ct d));
		                                                         };
		                                                         (True,c,d,fs,ms) -> case mdecl m ms of {
			                                                        Just (o,r,n,ps,b) -> (mtype fm ct omegas m (getPred ct (c,phi))) ++ [(fst (unzip ps),r)];
			                                                        Nothing -> (mtype fm ct omegas m (getPred ct (c,phi)));
		                                                         };
		                                                       }
		                         | (never fm omegas phi) = case (getClass ct (c,phi)) of {
								                                 (False,c,d,fs,ms) -> (mtype fm ct omegas m (getPred ct (c,phi))) ++ (mtype fm ct omegas m (getLast ct d));
		                                                         (True,c,d,fs,ms) -> (mtype fm ct omegas m (getPred ct (c,phi)));
		                                                       };
}