
module FFJPL.Test where {
	import FFJ.Syntax;
	import FFJ.Parser;
	import FFJ.Adapter;
	import FFJ.Print;
	import FFJ.Semantics;
	import FFJPL.Definitions;
	import FFJPL.Functions;
	import FFJPL.Predicates;
	import FFJPL.FeatureModel;
	import FFJPL.Subtype;
	import FFJPL.Load;
	import FFJPL.Navigation;
	import FFJPL.FieldLookup;
	import FFJPL.MethodLookup;
	import FFJPL.Wellformedness;
	import FFJPL.SanityConditions;
	import FFJPL.Programs;
	import Maybe;
	import Monad;
	import List;
	import Debug.Trace;

	main = do {
		(ct,pt,fm) <- load "FFJPL/test/F.features";
		
--		printct ct;
--		printpt pt;	
				
		when ((sanityConditionsOK fm ct) && (classesAndRefinementsOK fm ct) && (programsOK fm ct pt)) (print "Type checking was successful!") 
	};
}
